--- browser_eng.c	2002-11-24 08:09:07.000000000 -0500
+++ browser_eng.c	2014-12-27 23:05:03.000000000 -0500
@@ -44,4 +44,7 @@
 #endif
 #include <stdio.h>
+#include <stdlib.h>
+
+#include <X11/Xlib.h>
 
 #include "proto_decl.h"
@@ -55,12 +58,18 @@
 #include "browser_pars.h"
 #include "browser_util.h"
-
+#include "browser_init.h"
+#include "browser_eve.h"
+#include "list_box.h"
+#include "main_text.h"
+#include "result_types.h"
+#include "BR_Global.h"
+#include "Smac/smacXcoral.h"
 
 
 /*------------------------------------------------------------------------------
 */
-StringTable* get_files_list () {
+StringTable get_files_list () {
   FileRec*     current_file;
-  StringTable* result;
+  StringTable  result;
   char**       current_entry;
   int          index;
@@ -68,7 +77,7 @@ StringTable* get_files_list () {
 
   x_size = sizeof(char*) * (file_count + 1);
-  result = (StringTable*) xmalloc(x_size);
+  result = xmalloc(x_size);
   if (result != Null) {
-    current_entry = (char**) result;
+    current_entry = result;
     for (index = 0; index < FILE_DICT_SIZE; index++) {
       current_file = file_dict[index];
@@ -108,8 +117,8 @@ static int hiden_because_child(current_c
 }
 
-StringTable* get_classes_list ()
+StringTable get_classes_list ()
 {
   ClassRec*    current_class;
-  StringTable* result;
+  StringTable  result;
   char**       current_entry;
   int          index;
@@ -118,7 +127,7 @@ StringTable* get_classes_list ()
   
   x_size = sizeof(char*) * (class_count + 1);
-  result = (StringTable*) xmalloc(x_size);
+  result = xmalloc(x_size);
   if (result != Null) {
-    current_entry = (char**) result;
+    current_entry = result;
     for (index = 0; index < CLASS_DICT_SIZE; index++) {
       current_class = class_dict[index];
@@ -160,9 +169,47 @@ StringTable* get_classes_list ()
 /*------------------------------------------------------------------------------
 */
-StringTable* get_parents_list (class_name, obj)
-    char* class_name;
-    int obj;
+ParentRec **get_parents_recs (class_name)
+    const char* class_name;
 {
-  StringTable* result;
+  ParentRec ** result;
+  ParentRec ** current_entry;
+  ClassRec*    current_class;
+  ClassRec*    parent_class;
+  ParentRec*   current_parent;
+  int          x_size;
+  char*        infos;
+
+  current_class = find_class(class_name);
+  if (current_class == Null)
+    return Null;
+  x_size = sizeof(ParentRec *) * (current_class->_parents_count + 1);
+  result = xmalloc(x_size);
+  if (result == Null)
+    return Null;
+
+  current_entry  = result;
+  current_parent = current_class->_parents_list;
+  while (current_parent != Null) {
+    (*current_entry) = current_parent;
+    infos = current_parent->_name - CLASS_PLENGTH + 1;
+    parent_class = find_class(current_parent->_name);
+    if ((parent_class != Null) && (parent_class->_decl_file != Null))
+      *infos = 'd';
+    else
+      *infos = '?';
+    infos = current_parent->_name - CLASS_PLENGTH + 1;
+    current_entry++;
+    current_parent = current_parent->_next;
+  }
+  (*current_entry) = Null;
+  return(result);
+}
+
+/*------------------------------------------------------------------------------
+*/
+StringTable get_parents_list (class_name)
+    const char* class_name;
+{
+  StringTable  result;
   char**       current_entry;
   ClassRec*    current_class;
@@ -172,31 +219,27 @@ StringTable* get_parents_list (class_nam
   char*        infos;
 
-  result = Null; 
   current_class = find_class(class_name);
-  if (current_class != Null) {
-    x_size = sizeof(char*) * (current_class->_parents_count + 1);
-    result = (StringTable*) xmalloc(x_size);
-    if (result != Null) {
-      current_entry  = (char**) result;
-      current_parent = current_class->_parents_list;
-      while (current_parent != Null) {
-	if (obj)
-	  (*current_entry) = (char *) current_parent;
-	else
-	  (*current_entry) = current_parent->_name;
-	infos = current_parent->_name - CLASS_PLENGTH + 1;
-	parent_class = find_class(*current_entry);
-	if ((parent_class != Null) && (parent_class->_decl_file != Null))
-	  *infos = 'd';
-	else
-	  *infos = '?';
-	current_entry++;
-	current_parent = current_parent->_next;
-      }
-      (*current_entry) = Null;
-      if (!obj)
-	qsort(result, current_class->_parents_count, sizeof(char*), sort_util);
-    }
+  if (current_class == Null)
+    return Null;
+  x_size = sizeof(char *) * (current_class->_parents_count + 1);
+  result = xmalloc(x_size);
+  if (result == Null)
+    return Null;
+
+  current_entry  = result;
+  current_parent = current_class->_parents_list;
+  while (current_parent != Null) {
+    (*current_entry) = current_parent->_name;
+    infos = current_parent->_name - CLASS_PLENGTH + 1;
+    parent_class = find_class(current_parent->_name);
+    if ((parent_class != Null) && (parent_class->_decl_file != Null))
+      *infos = 'd';
+    else
+      *infos = '?';
+    current_entry++;
+    current_parent = current_parent->_next;
   }
+  (*current_entry) = Null;
+  qsort(result, current_class->_parents_count, sizeof(char*), sort_util);
   return(result);
 }
@@ -205,6 +248,6 @@ StringTable* get_parents_list (class_nam
 /*------------------------------------------------------------------------------
 */
-StringTable* get_sons_list(class_name)
-    char* class_name;
+StringTable get_sons_list(class_name)
+    const char* class_name;
 {
   int          index;
@@ -213,5 +256,5 @@ StringTable* get_sons_list(class_name)
   ClassRec*    current_class;
   ParentRec*   current_parent;
-  StringTable* result;
+  StringTable  result;
   char**       current_entry;
   int          x_size;
@@ -236,7 +279,7 @@ StringTable* get_sons_list(class_name)
   }
   x_size = sizeof(char*) * (marked_count + 1);
-  result = (StringTable*) xmalloc(x_size);
+  result = xmalloc(x_size);
   if (result != Null) {
-    current_entry = (char**) result;
+    current_entry = result;
     while (marked_list != Null) {
       (*current_entry) = marked_list->_name;
@@ -264,11 +307,11 @@ int        marked_count;
 
 
-int sort_method(i,j)
-  char** i;
-  char** j;
-{
-  char* ti = *i;
-  char* tj = *j;
-  char* par_posit;
+static int sort_method(i,j)
+  const char** i;
+  const char** j;
+{
+  const char* ti = *i;
+  const char* tj = *j;
+  const char* par_posit;
   int   result;
 
@@ -296,6 +339,6 @@ int sort_method(i,j)
 
 
-void post_compute(result)
-    StringTable* result;
+static void post_compute(result)
+    StringTable result;
 {
   char**  current_entry;
@@ -337,6 +380,6 @@ void post_compute(result)
 
 
-void get_inherit_list(current_class, max_scope, depth)
-     ClassRec* current_class;
+static void get_inherit_list(current_class, max_scope, depth)
+     const ClassRec* current_class;
      ScopeType max_scope;
      int       depth;
@@ -370,11 +413,11 @@ void get_inherit_list(current_class, max
 
 
-StringTable* get_methods_list(class_name, cut)
-    char* class_name;
+StringTable get_methods_list(class_name, cut)
+    const char* class_name;
     int cut;
 {
   ClassRec*    current_class;
   MethodRec*   current_method;
-  StringTable* result;
+  StringTable  result;
   char**       current_entry;
   int          x_size;
@@ -389,7 +432,7 @@ StringTable* get_methods_list(class_name
     if (marked_list != END_MARKED_LIST)  {
       x_size = sizeof(char*) * (marked_count + 1);
-      result = (StringTable*) xmalloc(x_size);
+      result = xmalloc(x_size);
       if (result != Null) {
-        current_entry  = (char**) result;
+        current_entry  = result;
         current_method = marked_list;
         while(current_method != END_MARKED_LIST) {
@@ -461,6 +504,6 @@ int marked_attr_count;
 #define END_MARKED_LIST ((AttributeRec*) 0x00000001)
 
-void get_inherit_attr_list(current_class, max_scope, depth)
-     ClassRec* current_class;
+static void get_inherit_attr_list(current_class, max_scope, depth)
+     const ClassRec* current_class;
      ScopeType max_scope;
      int       depth;
@@ -493,7 +536,7 @@ void get_inherit_attr_list(current_class
 }
 
-int sort_attribute(i,j)
-  char** i;
-  char** j;
+static int sort_attribute(i,j)
+  const char** i;
+  const char** j;
 {
   int result = strcmp(*i, *j);
@@ -512,11 +555,11 @@ int sort_attribute(i,j)
 }
 
-StringTable* get_attributes_list(class_name, cut)
-    char* class_name;
+StringTable get_attributes_list(class_name, cut)
+    const char* class_name;
     int cut;
 {
   ClassRec*    current_class;
   AttributeRec*   current_attr;
-  StringTable* result;
+  StringTable  result;
   char**       current_entry;
   int          x_size;
@@ -531,7 +574,7 @@ StringTable* get_attributes_list(class_n
     if (marked_attr_list != END_MARKED_LIST)  {
       x_size = sizeof(char*) * (marked_attr_count + 1);
-      result = (StringTable*) xmalloc(x_size);
+      result = xmalloc(x_size);
       if (result != Null) {
-        current_entry  = (char**) result;
+        current_entry  = result;
         current_attr = marked_attr_list;
         while(current_attr != END_MARKED_LIST) {
@@ -587,5 +630,5 @@ StringTable* get_attributes_list(class_n
 */
 Position* get_class_decl (class_name)
-    char* class_name;
+    const char* class_name;
 {
   Position*     result;
@@ -598,5 +641,5 @@ Position* get_class_decl (class_name)
   if (   (current_class != Null)
       && (current_class->_decl_file != Null)
-      && ((result = (Position*) xmalloc(x_size)) != Null)) {
+      && ((result = xmalloc(x_size)) != Null)) {
     result->file_name   = current_class->_decl_file->_name;
     result->line_number = current_class->_decl_line;
@@ -608,6 +651,6 @@ Position* get_class_decl (class_name)
 /*------------------------------------------------------------------------------
 */
-char* get_method_class(method_name)
-    char* method_name;
+const char* get_method_class(method_name)
+    const char* method_name;
 {
   MethodRec* current_method;
@@ -623,6 +666,6 @@ char* get_method_class(method_name)
 */
 Position* get_method_decl (class_name, method_name)
-    char* class_name;
-    char* method_name;
+    const char* class_name;
+    const char* method_name;
 {
   Position*     result;
@@ -643,5 +686,5 @@ Position* get_method_decl (class_name, m
     if (   (current_method != Null)
         && (current_method->_decl_file != Null)
-        && ((result = (Position*) xmalloc(x_size)) != Null)) {
+        && ((result = xmalloc(x_size)) != Null)) {
       result->file_name   = current_method->_decl_file->_name;
       result->line_number = current_method->_decl_line;
@@ -655,6 +698,6 @@ Position* get_method_decl (class_name, m
 */
 Position* get_method_impl (class_name, method_name)
-     char* class_name;
-     char* method_name;
+     const char* class_name;
+     const char* method_name;
 {
   Position*     result;
@@ -675,5 +718,5 @@ Position* get_method_impl (class_name, m
     if (   (current_method != Null)
         && (current_method->_impl_file != Null)
-        && ((result = (Position*) xmalloc(x_size)) != Null)) {
+        && ((result = xmalloc(x_size)) != Null)) {
       result->file_name   = current_method->_impl_file->_name;
       result->line_number = current_method->_impl_line;
@@ -686,6 +729,6 @@ Position* get_method_impl (class_name, m
 /*------------------------------------------------------------------------------
 */
-char* get_attribute_class(attr_name)
-    char* attr_name;
+const char* get_attribute_class(attr_name)
+    const char* attr_name;
 {
   AttributeRec* current_attr;
@@ -701,6 +744,6 @@ char* get_attribute_class(attr_name)
 */
 Position* get_attribute_decl (class_name, attr_name)
-    char* class_name;
-    char* attr_name;
+    const char* class_name;
+    const char* attr_name;
 {
   Position*     result;
@@ -721,5 +764,5 @@ Position* get_attribute_decl (class_name
     if (   (current_attr != Null)
         && (current_attr->_decl_file != Null)
-        && ((result = (Position*) xmalloc(x_size)) != Null)) {
+        && ((result = xmalloc(x_size)) != Null)) {
       result->file_name   = current_attr->_decl_file->_name;
       result->line_number = current_attr->_decl_line;
@@ -732,65 +775,104 @@ Position* get_attribute_decl (class_name
 /*------------------------------------------------------------------------------
 */
-StringTable* get_procs_list (prefix)
-    char * prefix;
+ProcRec ** get_procs_recs (prefix)
+    const char * prefix;
 {
   ProcRec*     current_proc;
-  StringTable* result;
-  char**       current_entry;
+  ProcRec**    result;
+  ProcRec**    current_entry;
   int          index;
   int          x_size;
   char*        infos;
   unsigned pfxlen;
-  x_size = sizeof(char*) * (proc_count + 1);
-  result = (StringTable*) xmalloc(x_size);
-  if (result != Null) {
-    if (prefix)
-      pfxlen = strlen(prefix);
-    current_entry = (char**) result;
-    for (index = 0; index < PROC_DICT_SIZE; index++) {
-      current_proc = proc_dict[index];
-      while(current_proc != Null) {
-	if (prefix) {
-	  if (strncmp(current_proc->_name, prefix, pfxlen)) {
-	    current_proc = current_proc->_next;
-	    continue;
-	  }
-	  (*current_entry) = (char *) current_proc;
-	}
-	else
-	  (*current_entry) = current_proc->_name;
-	infos = current_proc->_name - PROC_PLENGTH + 1;
-	if (current_proc->_decl & STATIC_PROC)
-	  infos[0] = 's';
-	if (current_proc->_decl & INLINE_PROC)
+
+  x_size = sizeof(ProcRec *) * (proc_count + 1);
+  result = xmalloc(x_size);
+  if (result == Null)
+    return NULL;
+
+  pfxlen = strlen(prefix);
+  current_entry = result;
+  for (index = 0; index < PROC_DICT_SIZE; index++) {
+    for (current_proc = proc_dict[index]; current_proc != Null;
+         current_proc = current_proc->_next) {
+      if (strncmp(current_proc->_name, prefix, pfxlen))
+	continue;
+      (*current_entry) = current_proc;
+      infos = current_proc->_name - PROC_PLENGTH + 1;
+      if (current_proc->_decl & STATIC_PROC)
+	infos[0] = 's';
+      if (current_proc->_decl & INLINE_PROC)
 	  infos[1] = 'I';
-	if (current_proc->_decl & TEMPLATE_PROC)
+      if (current_proc->_decl & TEMPLATE_PROC)
 	  infos[2] = 'T';
-	if ((current_proc->_decl & STATIC_PROC) &&
+      if ((current_proc->_decl & STATIC_PROC) &&
 	    (Hide_Bits & HideStaticFunctions)) {
 	  current_proc->_hide |= HideStaticFunctions;
 	  HIDE(current_proc->_name);
-	}
-	else
-	  current_proc->_hide &= ~HideStaticFunctions;
-	if (current_proc->_hide & UserHide)
-	  HIDE(current_proc->_name);
-	else if (! current_proc->_hide)
-	  SHOW(current_proc->_name);
-
-	current_entry++;
-	current_proc = current_proc->_next;
       }
+      else
+	current_proc->_hide &= ~HideStaticFunctions;
+      if (current_proc->_hide & UserHide)
+	HIDE(current_proc->_name);
+      else if (! current_proc->_hide)
+	SHOW(current_proc->_name);
+
+      current_entry++;
     }
-    (*current_entry) = Null;
-    if (prefix) {
-      if (! *result) {
-	free(result);
-	return 0;
+  }
+  if (current_entry == result) {
+    free(result);
+    return NULL;
+  }
+  (*current_entry) = Null;
+  return(result);
+}
+
+
+/*------------------------------------------------------------------------------
+*/
+StringTable get_procs_list ()
+{
+  ProcRec*     current_proc;
+  StringTable  result;
+  char**       current_entry;
+  int          index;
+  int          x_size;
+  char*        infos;
+
+  x_size = sizeof(char*) * (proc_count + 1);
+  result = xmalloc(x_size);
+  if (result == Null)
+    return NULL;
+
+  current_entry = result;
+  for (index = 0; index < PROC_DICT_SIZE; index++) {
+    for (current_proc = proc_dict[index]; current_proc != Null;
+         current_proc = current_proc->_next) {
+      (*current_entry) = current_proc->_name;
+      infos = current_proc->_name - PROC_PLENGTH + 1;
+      if (current_proc->_decl & STATIC_PROC)
+	infos[0] = 's';
+      if (current_proc->_decl & INLINE_PROC)
+	  infos[1] = 'I';
+      if (current_proc->_decl & TEMPLATE_PROC)
+	  infos[2] = 'T';
+      if ((current_proc->_decl & STATIC_PROC) &&
+	    (Hide_Bits & HideStaticFunctions)) {
+	  current_proc->_hide |= HideStaticFunctions;
+	  HIDE(current_proc->_name);
       }
+      else
+	current_proc->_hide &= ~HideStaticFunctions;
+      if (current_proc->_hide & UserHide)
+	HIDE(current_proc->_name);
+      else if (! current_proc->_hide)
+	SHOW(current_proc->_name);
+
+      current_entry++;
     }
-    else
-      qsort(result, proc_count, sizeof(char*), sort_util);
   }
+  (*current_entry) = Null;
+  qsort(result, proc_count, sizeof(char*), sort_util);
   return(result);
 }
@@ -800,5 +882,5 @@ StringTable* get_procs_list (prefix)
 */
 Position* get_proc_impl (proc_name)
-    char* proc_name;
+    const char* proc_name;
 {
   Position*     result;
@@ -811,5 +893,5 @@ Position* get_proc_impl (proc_name)
   if (   (current_proc != Null)
       && (current_proc->_impl_file != Null)
-      && ((result = (Position*) xmalloc(x_size)) != Null)) {
+      && ((result = xmalloc(x_size)) != Null)) {
     result->file_name   = current_proc->_impl_file->_name;
     result->line_number = current_proc->_impl_line;
@@ -819,67 +901,101 @@ Position* get_proc_impl (proc_name)
 
 
+/*------------------------------------------------------------------------------
+*/
+GlobalRec** get_globals_recs(prefix)
+    const char * prefix;
+{
+  GlobalRec*   current_global;
+  GlobalRec**  result;
+  GlobalRec**  current_entry;
+  int          index;
+  int          x_size;
+  char*        infos;
+  unsigned pfxlen;
+
+  x_size = sizeof(GlobalRec*) * (global_count + 1);
+  result = xmalloc(x_size);
+  if (result == Null)
+    return NULL;
+  if (prefix)
+    pfxlen = strlen(prefix);
+  current_entry = result;
+  for (index = 0; index < GLOBAL_DICT_SIZE; index++) {
+    for (current_global = global_dict[index]; current_global != Null;
+         current_global = current_global->_next) {
+      if (strncmp(current_global->_name, prefix, pfxlen))
+	continue;
+      (*current_entry) = current_global;
+      infos = current_global->_name - GLOBAL_PLENGTH + 1;
+      if (current_global->_static) {
+        *(infos) = 's';
+        if (Hide_Bits & HideStaticGlobals)
+          current_global->_hide |= HideStaticGlobals;
+        else
+          current_global->_hide &= ~HideStaticGlobals;
+        HIDE(current_global->_name);
+      }
+      else {
+        current_global->_hide &= ~HideStaticGlobals;
+        *(infos) = ' ';
+      }
+      if (current_global->_hide & UserHide)
+        HIDE(current_global->_name);
+      else if (! current_global->_hide)
+        SHOW(current_global->_name);
+      current_entry++;
+    }
+  }
+  if (result == current_entry) {
+    free(result);
+    return NULL;
+  }
+  (*current_entry) = Null;
+  return(result);
+}
+
 
 /*------------------------------------------------------------------------------
 */
-StringTable* get_globals_list(prefix)
-    char * prefix;
+StringTable get_globals_list()
 {
   GlobalRec*   current_global;
-  StringTable* result;
+  StringTable  result;
   char**       current_entry;
   int          index;
   int          x_size;
   char*        infos;
-  unsigned pfxlen;
 
   x_size = sizeof(char*) * (global_count + 1);
-  result = (StringTable*) xmalloc(x_size);
-  if (result != Null) {
-    if (prefix)
-      pfxlen = strlen(prefix);
-    current_entry = (char**) result;
-    for (index = 0; index < GLOBAL_DICT_SIZE; index++) {
-      current_global = global_dict[index];
-      while(current_global != Null) {
-	if (prefix) {
-	  if (strncmp(current_global->_name, prefix, pfxlen)) {
-	    current_global = current_global->_next;
-	    continue;
-	  }
-	  (*current_entry) = (char *) current_global;
-	}
-	else
-	  (*current_entry) = current_global->_name;
-	infos = (*current_entry) - GLOBAL_PLENGTH + 1;
-	if (current_global->_static) {
-	  *(infos) = 's';
-	  if (Hide_Bits & HideStaticGlobals)
-	    current_global->_hide |= HideStaticGlobals;
-	  else
-	    current_global->_hide &= ~HideStaticGlobals;
-	  HIDE(current_global->_name);
-	}
-	else {
-	  current_global->_hide &= ~HideStaticGlobals;
-	  *(infos) = ' ';
-	}
-	if (current_global->_hide & UserHide)
-	  HIDE(current_global->_name);
-	else if (! current_global->_hide)
-	  SHOW(current_global->_name);
-	current_entry++;
-	current_global = current_global->_next;
+  result = xmalloc(x_size);
+  if (result == Null)
+    return NULL;
+  current_entry = result;
+  for (index = 0; index < GLOBAL_DICT_SIZE; index++) {
+    for (current_global = global_dict[index]; current_global != Null;
+         current_global = current_global->_next) {
+      (*current_entry) = current_global->_name;
+      infos = current_global->_name - GLOBAL_PLENGTH + 1;
+      if (current_global->_static) {
+        *(infos) = 's';
+        if (Hide_Bits & HideStaticGlobals)
+          current_global->_hide |= HideStaticGlobals;
+        else
+          current_global->_hide &= ~HideStaticGlobals;
+        HIDE(current_global->_name);
       }
-    }
-    (*current_entry) = Null;
-    if (prefix) {
-      if (! *result) {
-	free(result);
-	return 0;
+      else {
+        current_global->_hide &= ~HideStaticGlobals;
+        *(infos) = ' ';
       }
+      if (current_global->_hide & UserHide)
+        HIDE(current_global->_name);
+      else if (! current_global->_hide)
+        SHOW(current_global->_name);
+      current_entry++;
     }
-    else
-      qsort(result, global_count, sizeof(char*), sort_util);
   }
+  (*current_entry) = Null;
+  qsort(result, global_count, sizeof(char*), sort_util);
   return(result);
 }
@@ -889,5 +1005,5 @@ StringTable* get_globals_list(prefix)
 */
 Position* get_global_impl (global_name)
-    char* global_name;
+    const char* global_name;
 {
   Position*     result;
@@ -900,5 +1016,5 @@ Position* get_global_impl (global_name)
   if (   (current_global != Null)
       && (current_global->_impl_file != Null)
-      && ((result = (Position*) xmalloc(x_size)) != Null)) {
+      && ((result = xmalloc(x_size)) != Null)) {
     result->file_name   = current_global->_impl_file->_name;
     result->line_number = current_global->_impl_line;
@@ -911,5 +1027,5 @@ Position* get_global_impl (global_name)
 */
 void parse_file(file_name)
-     char* file_name;
+     const char* file_name;
 {
   parsed_file = find_file(file_name);
@@ -932,5 +1048,5 @@ void parse_file(file_name)
 */
 void delete_file(file_name)
-     char* file_name;
+     const char* file_name;
 {
   if ((file_name == Null) || (find_file(file_name) != Null)) {
@@ -1009,11 +1125,7 @@ void browser_show_all()
 */
 void BrowserHide(selected_class_name)
-    char * selected_class_name;
+    const char * selected_class_name;
 {
-  FCT (void, ClearListBox, () );
-  FCT (void, FillList, (char *str) );
-  FCT (char *, SelectFromListBox, (char *msg) );
-
-  static char *msgs[] = {
+  static const char *msgs[] = {
     "show all",
     "show protected and private members",
@@ -1031,5 +1143,5 @@ void BrowserHide(selected_class_name)
     "hide children of selected class"
   };
-  char * str;
+  const char * str;
   ClassRec* parent =
     (selected_class_name) ? find_class(selected_class_name + CLASS_PLENGTH) : 0;
@@ -1053,5 +1165,5 @@ void BrowserHide(selected_class_name)
     FillList((parent->_hide & HideChildrenOf) ? msgs[12] : msgs[13]);
   
-  if (! (str = SelectFromListBox("Browser objects visibility")))
+  if ((str = SelectFromListBox()) == NULL)
     return;
   if (! strcmp(str, msgs[0]))
--- browser_eng.h	2002-11-24 08:09:17.000000000 -0500
+++ browser_eng.h	2014-12-27 03:07:55.000000000 -0500
@@ -42,4 +42,8 @@
 #define BROWSERENGINE_H
 
+#include "file_dict.h"
+#include "class_dict.h"
+#include "global_dict.h"
+#include "proc_dict.h"
 
 /*------------------------------------------------------------------------------
@@ -49,40 +53,42 @@
 //     structure de donnees alloue'e dynamiquement. Ce pointeur (et 
 //     uniquement lui) doit e^tre de'salloue' par un appel explicite
-//     a la fonction free().
+//     a la fonction free(void).
 //------------------------------------------------------------------------------
 */
 
-extern StringTable* get_files_list    ();
+extern StringTable get_files_list    (void);
 
 
-extern StringTable* get_classes_list  ();
+extern StringTable get_classes_list  (void);
 
-extern StringTable* get_parents_list  (/* char* class_name, int obj */);
+extern StringTable get_parents_list  (const char* class_name);
+extern ParentRec** get_parents_recs  (const char* class_name);
 
-extern StringTable* get_sons_list     (/* char* class_name */);
+extern StringTable get_sons_list     (const char* class_name);
 
-extern StringTable* get_methods_list  (/* char* class_name, int cut */);
+extern StringTable get_methods_list  (const char* class_name, int cut);
 
-extern StringTable* get_attributes_list  (/* char* class_name, int cut */);
+extern StringTable get_attributes_list(const char* class_name, int cut);
 
-extern Position*    get_class_decl    (/* char* class_name */);
+extern Position*    get_class_decl    (const char* class_name);
 
-extern Position*    get_method_decl   (/* char* class_name,
-				                          char* method_name */);
+extern Position*    get_method_decl   (const char* class_name,
+				       const char* method_name);
 
-extern Position*    get_method_impl   (/* char* class_name,
-				                          char* method_name */);
+extern Position*    get_method_impl   (const char* class_name,
+				       const char* method_name);
 
+extern StringTable get_procs_list    (void);
+extern ProcRec**   get_procs_recs    (const char * prefix);
 
-extern StringTable* get_procs_list    (/* char * prefix */);
+extern Position*   get_proc_impl     (const char* proc_name);
 
-extern Position*    get_proc_impl     (/* char* proc_name */);
+extern Position*   get_attribute_decl(const char* class_name,
+				      const char* method_name);
 
-extern Position*    get_attribute_decl   (/* char* class_name,
-				                          char* method_name */);
+extern StringTable get_globals_list  (void);
+extern GlobalRec** get_globals_recs  (const char * prefix);
 
-extern StringTable* get_globals_list    (/* char * prefix */);
-
-extern Position*    get_global_impl     (/* char* global_name */);
+extern Position*   get_global_impl   (const char* global_name);
 
 
@@ -92,9 +98,10 @@ extern Position*    get_global_impl     
 */
 
-extern void parse_file   (/* char* file_name */);
+extern void parse_file   (const char* file_name);
 
-extern void delete_file  (/* char* file_name */);
+extern void delete_file  (const char* file_name);
+extern void browser_show_all(void);
 
-extern void BrowserHide (/* char * selected_class_name */);
+extern void BrowserHide (const char * selected_class_name);
 
 #endif  /*  BROWSERENGINE_H  */
